SystemOrganization addCategory: #'BlackGold-Core'!

ALApplication subclass: #BGWikiApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGWikiApplication methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:47'!
initializeLocator
	locator 
		at: ALPath root 
		put: BGHomePage new asResource! !

Object subclass: #BGComponent
	instanceVariableNames: 'archive delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGComponent methodsFor: 'rendering' stamp: 'chc 4/18/2017 15:06'!
renderOn: html
	self renderContentOn: html! !

BGComponent subclass: #BGCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 15:40'!
initialize
	super initialize.
	count := 0.
	delegate := BGHelloWorld new. ! !

!BGCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 15:42'!
renderContentOn: html
	html a navigate: [count := count + 1]; with: '++'.
	html br.
	html span with: count asString.
	html br. 
	html a navigate: [count := count - 1]; with: '--'.
	delegate renderOn: html

	! !

BGComponent subclass: #BGHelloWorld
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 15:17'!
renderContentOn: html
	html p: 'Hello World'! !

Object subclass: #BGHomePage
	instanceVariableNames: 'examples current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHomePage methodsFor: 'converting' stamp: 'chc 4/18/2017 15:06'!
asResource
	^ BGHtmlResource component: self! !

!BGHomePage methodsFor: 'initialize-release' stamp: 'chc 4/18/2017 15:20'!
initialize
	examples := {
		'counter' -> BGCounter.
		'hello world' -> BGHelloWorld.
	}.
	current := examples first value new.! !

!BGHomePage methodsFor: 'rendering' stamp: 'chc 4/18/2017 14:51'!
renderBodyOn: html
	html div
		with: [current renderOn: html]! !

!BGHomePage methodsFor: 'rendering' stamp: 'chc 4/18/2017 14:44'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'BlackGold'].
		html body: [ self renderBodyOn: html ] ]! !

ALComponentResource subclass: #BGHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!BGHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !
